#include "runit.h"


//extern struct APP2RUN *ap_tmp;
//extern struct APP2RUN *ap;
//extern int iTmpApps;
extern BOOL UpdateIni(char*,int);
extern struct _SET Set_tmp[8];
extern struct _RUNit RUNit_tmp;


BOOL AddVirtualEntry(char* szDropFile,BOOL bGroup)
{
	//char sz[_MAX_PATH];
	char szFileName[_MAX_FNAME];
	char szExt[_MAX_EXT];
	char szWorkDir[_MAX_PATH];
	char szDrive[_MAX_PATH];
	DWORD dwFileAttrib;
	int apps;


	//allocate memory
	apps=Set_tmp[RUNit_tmp.iActiveSet].iApps+1;
	Set_tmp[RUNit_tmp.iActiveSet].ap=HeapReAlloc(GetProcessHeap(),0,Set_tmp[RUNit_tmp.iActiveSet].ap,sizeof(struct APP2RUN)*(apps));
	if(!Set_tmp[RUNit_tmp.iActiveSet].ap){
		MessageBox(NULL,"Error allocating memory for pointer ap_tmp","RUNit ERROR",MB_OK);
		return FALSE;
	}
	if(apps>0)
		ZeroMemory(&Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1],sizeof(struct APP2RUN));

	if (bGroup){
		//Fill the Stucture
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szAppPat,"GROUP");
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szAppTit,szDropFile);
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szFileExt, "GROUP");
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szWorkDir,"GROUP");
		//ICO
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szSymbolFile,"GROUP");
		Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].iRun=3;
	}

	else if (_stricmp(szDropFile,"SEPARATOR")){
		
		_splitpath(szDropFile,szDrive,szWorkDir,szFileName,szExt);

		//Fill the Stucture
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szAppPat,szDropFile);
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szAppTit,szFileName);
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szFileExt, szExt);

		dwFileAttrib=GetFileAttributes(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szAppPat);

		// File is Shortcut
		if ((!(_stricmp(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szFileExt,".lnk")))||
			(!(_stricmp(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szFileExt,".pif"))) ){
			strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szWorkDir,"SHORTCUT PROPERTIES");
			Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].iRun=3;
		}

		// File is Directory
		else if	(dwFileAttrib&FILE_ATTRIBUTE_DIRECTORY){

			strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szWorkDir,"");
			Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].iRun=0;
		}

		// File is Executable
		else if ((!(_stricmp(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szFileExt,".exe")))||
			(!(_stricmp(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szFileExt,".com"))) ){
				strcat(szDrive,szWorkDir);
				strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szWorkDir,szDrive);
				Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].iRun=0;
		}

		// File is Document
		else{
			strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szWorkDir,"");
			Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].iRun=4;
		}

	}
	else{ //a SEPARATOR was added
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szAppPat,"SEPARATOR");
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szAppTit,"----------------");
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szWorkDir,"");
		strcpy(Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].szFileExt,"");
		Set_tmp[RUNit_tmp.iActiveSet].ap[apps-1].iRun=4;
	}

	Set_tmp[RUNit_tmp.iActiveSet].iApps++;
	return TRUE;
}

BOOL DeleteSet(struct _RUNit *prunit, struct _SET *pset, int iset)
{
	int i;

	//last one ? that's easy...
	if(iset==prunit->iNumSets-1){
		prunit->iNumSets--;
	}
	//first or other? a bit more to do ...
	else{
		for(i=iset;i<prunit->iNumSets-1;i++){
			CopyMemory(&pset[i],&pset[i+1],sizeof(struct _SET));
		}
		prunit->iNumSets--;
	}
	//check if used?
	if(RUNit_tmp.hotRegion[HOT_RIGHTTOP].iSet==iset)
		RUNit_tmp.hotRegion[HOT_RIGHTTOP].iSet=-1;
	if(RUNit_tmp.hotRegion[HOT_RIGHTBOTTOM].iSet==iset)
		RUNit_tmp.hotRegion[HOT_RIGHTBOTTOM].iSet=-1;
	if(RUNit_tmp.hotRegion[HOT_LEFTTOP].iSet==iset)
		RUNit_tmp.hotRegion[HOT_LEFTTOP].iSet=-1;
	if(RUNit_tmp.hotRegion[HOT_LEFTBOTTOM].iSet==iset)
		RUNit_tmp.hotRegion[HOT_LEFTBOTTOM].iSet=-1;
	if(RUNit_tmp.hotRegion[HOT_TOPLEFT].iSet==iset)
		RUNit_tmp.hotRegion[HOT_TOPLEFT].iSet=-1;
	if(RUNit_tmp.hotRegion[HOT_TOPRIGHT].iSet==iset)
		RUNit_tmp.hotRegion[HOT_TOPRIGHT].iSet=-1;
	if(RUNit_tmp.hotRegion[HOT_BOTTOMLEFT].iSet==iset)
		RUNit_tmp.hotRegion[HOT_BOTTOMLEFT].iSet=-1;
	if(RUNit_tmp.hotRegion[HOT_BOTTOMRIGHT].iSet==iset)
		RUNit_tmp.hotRegion[HOT_BOTTOMRIGHT].iSet=-1;
	if(RUNit_tmp.hotRegion[HOT_CAPTION].iSet==iset)
		RUNit_tmp.hotRegion[HOT_CAPTION].iSet=-1;

	return TRUE;
}



